#!/bin/bash
#
#   Hitachi Raid Adapter Driver Installer for RHEL5
#
#   $Header: /home/cvs_linux_driver/trunk/Linux_Driver/tools/install/hrainst.el5.sh,v 1.3 2008/12/05 07:58:15 inoue Exp $
#   $Log: hrainst.el5.sh,v $
#   Revision 1.3  2008/12/05 07:58:15  inoue
#   comment line delete # ignore
#
#   Revision 1.2  2008/11/07 07:21:34  raid
#   RHEL5.3 DUM support # ignore
#
#   Revision 1.1.1.1  2008/11/05 11:42:39  raid
#   start
#
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hrainst.el5.sh install/uninstall [kvariant]"
        echo "example(install  ) : hrainst.el5.sh install"
        echo "       (uninstall) : hrainst.el5.sh uninstall"
        exit 1
fi
DRVDIR="drivers"
DRVMODU="hradrv"
HOSTTYPE=$(uname -m)
TOOLSDIR="/opt/hitachi/drivers/hra"
INSTLOG="/tmp/hradrv_install.log"
if [ "$HOSTTYPE" = "i686" ] && [ "$2" = "PAE" ]; then
	KERN50="2.6.18-8.el5PAE"
	KERN51="2.6.18-53.el5PAE"
	KERN52="2.6.18-92.el5PAE"
	KERN53="2.6.18-120.el5PAE"
	if [ `uname -r | grep "PAE"` ]; then
		KERNVER=`uname -r`
	else
		KERNVER="`uname -r`PAE"
	fi
elif [ "$HOSTTYPE" = "i686" ]; then
	KERN50="2.6.18-8.el5"
	KERN51="2.6.18-53.el5"
	KERN52="2.6.18-92.el5"
	KERN53="2.6.18-120.el5"
	KERNVER=`uname -r | sed -e 's/PAE//'`
else
	KERN50="2.6.18-8.el5"
	KERN51="2.6.18-53.el5"
	KERN52="2.6.18-92.el5"
	KERN53="2.6.18-120.el5"
	KERNVER=`uname -r`
fi
KERNEL2=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,\..*,,'`
KERNEL3=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,[^\.]*\.,,' -e 's,\-.*,,'`
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo "      Boot directory      : $BOOTDIR" > $INSTLOG
if [ $KERNEL2 = "4" ] || [ $KERNEL3 = "9" ]; then
	echo " ---- Kernel version is 2.4 or 2.6.9 (/etc/$MODCONF)"  >> $INSTLOG
	exit 1
fi
MODCONF="modprobe.conf"
if [ ! -f "/etc/$MODCONF" ]; then
	echo " ---- No configuration file was found (/etc/$MODCONF)"  >> $INSTLOG
	exit 1
fi
DRVNAME="hradrv.ko"
echo "      Configulation file  : $MODCONF"    >> $INSTLOG
echo "      Kernel version      : $KERNVER"    >> $INSTLOG
echo "      Host Type           : `uname -m`"  >> $INSTLOG
if [ "$1" = "install" ]; then
	echo " ---- Install  @Hitachi Raid Adapter Driver - `date`" >> $INSTLOG
	find /lib/modules/$KERNVER/updates -name $DRVNAME -exec mv {} {}.backup \;
	find /lib/modules/$KERNVER/kernel  -name $DRVNAME -exec mv {} {}.backup \;
	echo "      Modify /etc/$MODCONF; old file is /etc/$MODCONF.backup"   >> $INSTLOG
	cp /etc/$MODCONF /etc/$MODCONF.backup
	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
	if [ `grep -c "scsi_hostadapter[0-9]*[[:space:]]\+hradrv" /etc/$MODCONF` -eq 0 ]; then
		COUNT=`grep -c "scsi_hostadapter" /etc/$MODCONF`
		if [ $COUNT -eq 0 ]; then
			echo "alias scsi_hostadapter0 hradrv" >> /etc/$MODCONF
		elif [ $COUNT -eq 1 ]; then
			#########################################################################################################
			#
			# the following cases:
			#  1. alias scsi_hostadapter xxxxxx
			#
			#  2. alias scsi_hostadapterN xxxxxx
			#
			# after modified:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapter1 hradrv
			#
			#  2. alias scsi_hostadapterN xxxxxx
			#     alias scsi_hostadapterN+1 hradrv
			#
			#########################################################################################################
			if [ `grep -c "scsi_hostadapter[ ]" /etc/$MODCONF` -eq 0 ]; then
				COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/$MODCONF|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
				LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/$MODCONF`
				COUNT=`expr $COUNT + 1`
				sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
			else
				LN=`sed -n /scsi_hostadapter/{=} /etc/$MODCONF`
				sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
			fi
		else
			#########################################################################################################
			#
			# the following cases:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapterN xxxxxx
			#
			#  2. alias scsi_hostadapterM xxxxxx
			#     alias scsi_hostadapterN xxxxxx
			#
			# after modified:
			#  1. alias scsi_hostadapter xxxxxx
			#     alias scsi_hostadapterN+1 hradrv
			#
			#  2. alias scsi_hostadapterM xxxxxx
			#     alias scsi_hostadapterN+1 hradrv
			#
			#########################################################################################################
			cp /etc/$MODCONF /etc/$MODCONF.temp
			ADAP=`grep -c "scsi_hostadapter[ ]" /etc/$MODCONF`
			ADAP0=`grep -c "scsi_hostadapter0*0[ ]" /etc/$MODCONF`
			if [ $ADAP -gt 2 ] || [ $ADAP0 -gt 2 ]; then
				echo " @ERR double assigned scsi_hostadapter number" >> $INSTLOG
				sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
				mv /etc/$MODCONF.temp /etc/$MODCONF
				exit 1
			fi
			if [ $ADAP -eq 1 ]; then
				# intentional character
				sed s/"scsi_hostadapter "/"scsi_xxxxxxxxxxx "/ /etc/$MODCONF > /etc/$MODCONF.temp
			fi
			COUNT=`sed -n s/alias[[:space:]]*scsi_hostadapter//p /etc/$MODCONF.temp|awk 'BIGIN{n=0};$1>n{n=$1};END{print n}'`
			LN=`sed -n /scsi_hostadapter0*$COUNT/{=} /etc/$MODCONF.temp`
			COUNT=`expr $COUNT + 1`
			sed "$LN"a"alias scsi_hostadapter$COUNT hradrv" /etc/$MODCONF > /etc/$MODCONF.temp
			mv /etc/$MODCONF.temp /etc/$MODCONF
		fi
	fi
	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
	echo " ---- Install Success "   >> $INSTLOG
else
	echo " ---- Uninstall  @Hitachi Raid Adapter Driver - `date`"   > $INSTLOG
	echo "      Modify /etc/$MODCONF"   >> $INSTLOG
	sed '/^#/s/scsi_hostadapter/hoge_hogehoge/g' /etc/$MODCONF > /etc/$MODCONF.temp
	sed '/alias scsi_hostadapter.* hradrv/d' /etc/$MODCONF.temp > /etc/$MODCONF
	rm /etc/$MODCONF.temp
	cp /etc/$MODCONF /etc/$MODCONF.temp
	sed '/^#/s/hoge_hogehoge/scsi_hostadapter/g' /etc/$MODCONF > /etc/$MODCONF.temp
	mv /etc/$MODCONF.temp /etc/$MODCONF
    echo " ---- Uninstall Success "   >> $INSTLOG
fi
